// Librairie de fonctions JavaScript
// DOIT tre inclue par une balise
// SCRIPT langage="JavaScript1.1" SRC="formLib.js"

//---------------------------------------------------
// Application 	: *
// File 	: formLib.js
// Author 	: JM Inglebert
// Institution  : VALORIA/ORCADE
// Mail 	: Jean-Michel.Inglebert@iu-vannes.fr
// Date		: 13/04/98
//---------------------------------------------------
   function rcsId(){ return "$Id: formLib.js,v 1.1 1998/05/01 07:49:20 queinnec Exp $" }
//---------------------------------------------------
// Librairie de fonctions de cration d'lments
// d'interface
// Chaque lment est cr dans une window quelconque
// donc chaque handler doit tre rfrenc via la
// window qui le contient
// x 
// 
//---------------------------------------------------
// TODO
// - passer la taille des select multiples en parametre
// - produire des chaines (virer les d.write)
// TODO
//---------------------------------------------------


debug = false


//-------------------------------------------------
// Procedure doInput
// ---
// Gnre puis affiche la chaine de construction
// d'un champ INPUT quelconque
// ---
function doInput(win,type,name,value,size,event1,handler1) 
// win       # target window
// type      # "text" or "button", "radio" if only one is necessary
// name      #
// value     #
// size      # only used if type=="text"
// event1    # optionnal
// handler1  # required if event1
// event2    # 
// handler2  #
// ...
{

 var command = "" ;

 command += "<INPUT TYPE='" + type
 command += "' NAME='" + name 
 command += "' VALUE='" + value 
 if (type == "text")
  {command += "' SIZE='" + size }

 for (i=5; i<doInput.arguments.length; i+=2)
  {
   command += "' " + doInput.arguments[i] + "='"
   command += doInput.arguments[i+1]
  }
 command += "' >" ;

 win.document.write(command);
}

//-------------------------------------------------
// Procedure doRadios
// ---
// Gnre puis affiche la chaine de construction
// d'un champ Radio quelconque
// ---
function doChecks(win,type,tabItems,tabValues,name,code,isel){
// win        #
// type       # "radio" or "checkbox"
// tabItems   # tableau des noms des items de la liste
// tabValues  # tableau des valeurs associes aux items de la liste
// name # nom de l'lment Radio
// code # handler pour l'evnement onClick
// isel # indice de l'lment pr-slectionn

// --
// Construit un lment de type Radio
// o les items sont les lments du tableau tabItems
// et leurs valeurs associes les lments du tableau tabValues
// --

 for (var i = 0; i<tabItems.length ; i++)
 {
  win.document.write("<INPUT TYPE='",type,"' NAME=",name)
  win.document.write(" VALUE='", tabValues[i],"' ")
  if (i == isel)
   {win.document.write(" CHECKED ")}
  win.document.write(" OnClick='",code,"' >")
  win.document.write(tabItems[i])
 }
}


//-------------------------------------------------
// Procedure doSelect
// ---
// Gnre puis affiche la chaine de construction
// d'un champ SELECT quelconque
// ---
function doSelect(win,tabItems,tabValues,name,code,isel){
// win
// tabItems   # tableau des noms des items de la liste
// tabValues  # tableau des valeurs associes aux items de la liste
// name # nom de l'lment SELECT
// code # handler pour l'evnement onChange
// isel : string or Array # indice(s) de l'lment pr-slectionn 

// --
// Construit un lment de type SELECT
// o les items sont les lments du tableau tabItems
// et leurs valeurs associes les lments du tableau tabValues
// --

 win.document.write("<SELECT NAME=",name)

 if (typeof(isel) != "string") 
  { 
   win.document.write(" MULTIPLE ") 
   win.document.write(" SIZE='5' ")
  }

 win.document.write(" OnChange='",code,"' >")
 for (var i = 0; i<tabItems.length ; i++){
  win.document.write("<OPTION VALUE='", tabValues[i])
  win.document.write("' ")
  if ((typeof(isel) == "string") && (isel==tabItems[i]))
   {
    win.document.write(" SELECTED")
   }
  if ((typeof(isel) != "string") && member(tabItems[i],isel))
   {
    win.document.write(" SELECTED")
   }
  win.document.write(" > ", tabItems[i])
 }
 win.document.write("</SELECT>")

}

//-------------------------------------------------
// Procedure razElements
// ---
// Clear the value field of all the form's elements with the given name
// ---

function razElements(form,elName)
// form # 
// elName # form elements name to clear
{
 for (var i=0;i<form.elements.length;i++)
   {if (form.elements[i].name == elName) {form.elements[i].value=""}}
}




//--
// member(element,tab)
//--
function member(element,tab)
{
 for (var i=0;i<tab.length;i++)
  {
   if (tab[i]==element) {return true}
  }
 return false
}

//--
// inspecte un objet quelconque
//--
function show_props(obj, obj_name) { 
    var result = "" 
    for (var i in obj) 
        result += obj_name + "." + i + " = " + obj[i] + "<BR>" 
    return result; 
} 
