;;; $Id: test-bgl.scm,v 1.4 1995/12/18 17:48:54 queinnec Exp $


;;; The normal error handler

(define (DM-normal-error . args)
  (display "*** *** *** *** *** DMeroon ERROR")
  (newline)
  (for-each (lambda (arg) (display arg) (display " "))                
            args )
  (newline)
  (display "*** *** *** *** *** END OF DMeroon ERROR")
  (newline)
  (DM-raise-error 11 "DMeroon error" "test.scm" 9999) )

(define DM-error DM-normal-error)

(define (DM-api-error . args)
  (apply DM-error args) )

(define (tester-error . args)
  (apply DM-error args) )

;;; Test the binding of DMeroon with Scheme

(define (test-DMeroon file)
  (try (suite-test 
        file
        "?? " "== " #t
        (lambda (read print err)
          (set! DM-error err)
          (lambda () 
            (try (print (eval (read)))
                 (lambda (k a b c) 
                   (notify-error a b c)
                   (err a b c) ) ) ) )
        equal? )
       (lambda (k a b c)
         (notify-error a b c)
         (set! DM-error DM-normal-error)
         (k 'ended) ) ) )
;;; Test: (test-DMeroon "DMeroon.tst")

;;; end of test-bgl.scm
