;;; $Id: test-osc.scm,v 1.2 1995/12/18 19:44:20 queinnec Exp $


;;; The normal error handler

(define (DM-normal-error . args)
  (display "*** *** *** *** *** DMeroon ERROR")
  (newline)
  (for-each (lambda (arg) (display arg) (display " "))                
            args )
  (newline)
  (display "*** *** *** *** *** END OF DMeroon ERROR")
  (newline)
  (DM-raise-error 11 "DMeroon error" "test.scm" 9999) )

(define DM-error DM-normal-error)

(define (tester-error . args)
  (apply DM-error args) )

(define (DM-api-error . args)
  (apply DM-error args) )

(define (eval e) (codeblock:execute (sys:compile (sys:expand e))))

;;; Test the binding of DMeroon with Scheme

(define (test-DMeroon file)
  (let ((ch (error-handler)))
    (suite-test
     file
     "?? " "== " #t
     (lambda (read print err)
       (set! DM-error err)
       (lambda ()
         (set-error-handler! 
          (lambda erroneous 
            (set-error-handler! ch)
            (err erroneous) ) )
         (print (eval (read))) ) )
     equal? )
    (set-error-handler! ch) ) )

;;; Test: (test-DMeroon "dmeroon.tst")

;;; end of test-osc.scm
