/////////////////////////////////////////////////////
// Static local data structures to capture
// DMeroon URLscript commands informations
/////////////////////////////////////////////////////

////////////////////////////////////////////////////////
////////////////////////////////////////////////////////
// to include with the following SCRIPT tag
// <SCRIPT langage="JavaScript1.1" SRC="dmDatas.js"></SCRIPT>

//---------------------------------------------------
// Application 	: *
// File 	: dmDatas.js
// Author 	: JM Inglebert
// Institution  : VALORIA/ORCADE
// Mail 	: Jean-Michel.Inglebert@univ-ubs.fr
// Date		: 16/04/98
//---------------------------------------------------
   function rcsId(){ return "$Id: dmDatas.js,v 1.1 1998/05/01 07:49:18 queinnec Exp $" }
//---------------------------------------------------
// x 
//---------------------------------------------------
// TODO
// - directly inspect DMeroon
// TODO
//---------------------------------------------------
////////////////////////////////////////////////////////
////////////////////////////////////////////////////////


//------------------------------------------------------
// DMeroon default predefined Classes, Types,...
//------------------------------------------------------
  dmClassNames  = new Array("Boolean"          ,"Char1"          ,"Clock"          ,"Date"          ,"Dictionary"          ,"Float1"          ,"Int1"          ,"Nat1"          ,"NetNat3"          ,"Object"          ,"MutableVector"          ,"Reference"          ,"String"          ,"null")
  dmClassValues = new Array("\"Boolean\" class","\"Char1\" class","\"Clock\" class","\"Date\" class","\"Dictionary\" class","\"Float1\" class","\"Int1\" class","\"Nat1\" class","\"NetNat3\" class","\"Object\" class","\"MutableVector\" class","\"Reference\" class","\"String\" class","null")

  dmClassOptionsNames  = new Array("default","mutable","immotile","stringent","volatile","hasNoReference","usable","notSubclassable","copyable","notInstanciable")
  dmClassOptionsValues = new Array(0        ,1<<0     ,1<<1      ,1<<2       ,1<<3      ,1<<4            ,1<<5    ,1<<6             ,1<<7      ,1<<8             )
  dmClassDefaultOptionsValues = new Array("default")

  dmTypeNames   = new Array("char1"         ,"date"         ,"float1"         ,"int1"         ,"nat1"         ,"netnat3"         ,"nought"         ,"reference")
  dmTypeValues  = new Array("\"char1\" type","\"date\" type","\"float1\" type","\"int1\" type","\"nat1\" type","\"netnat3\" type","\"nought\" type","\"reference\" type")

  dmFieldOptionsNames  = new Array("mutable","volatile","local","secret","default")
  dmFieldOptionsValues = new Array(1<<0     ,1<<1      ,1<<2   ,1<<4    ,0)
  dmFieldDefaultOptionsValues = new Array("mutable","local")

  dmFieldRepetitionTypes       = new Array("nought"         ,"nat1"         ,"nat2"         ,"nat3")
  dmFieldRepetitionTypesValues = new Array("\"nought\" type","\"nat1\" type","\"nat2\" type","\"nat3\" type")

  dmObjectNames = new Array("thesite","true","false")

//------------------------------------------------------
// Session defined Classes, Objects
//------------------------------------------------------
  sessionClassNames  = new Array("--session defined--")

  sessionObjectNames = new Array("--session defined--")

  sessionNames = new Array("--session defined--")

//------------------------------------------------------
// DMeroon and session defined Classes, Objects
//------------------------------------------------------
  allClassNames        = concat(dmClassNames ,sessionClassNames)

  allClassNamesValues  = concat(dmClassValues ,sessionClassNames)

  allObjectNames        = concat(dmObjectNames ,sessionObjectNames)

  allObjectNamesValues  = concat(dmObjectNames ,sessionObjectNames)

////////////////////////////////////////////////////////
////////////////////////////////////////////////////////
//------------------------------------------------------
// URLscript stack commands
//------------------------------------------------------
  dmStackCommands = new Array("dup","swap","pop","print")

//--------------------------------------------------------------
// URLscript commands applied to only one object, with no output
//--------------------------------------------------------------
  dmOnObject = new Array("byteprint","fancyprint","print","setsharable","setcopyable","tick")

//--------------------------------------------------------------
// URLscript commands applied to only one object, with one output
//--------------------------------------------------------------
  dmOnToObject = new Array("classof","siteof","clockof","clone")

////////////////////////////////////////////////////////
////////////////////////////////////////////////////////
////////////////////////////////////////////////////////

//------------------------------------------------------
// dmClient URLscript commands list
//------------------------------------------------------
  dmClientCommandNames   = new Array("","allocate"    ,"connect"    ,"createsubclass"    ,"define"    ,"get"    ,"if"    ,"literalString"    ,"modify"    ,"onObject"    ,"onToObject"    ,"set"    ,"setFromField"    ,"o o =="       ,"xget"    ,"xset"    )

  dmClientCommandObjects = new Array("","urlsAllocate","urlsConnect","urlsCreatesubclass","urlsDefine","urlsGet","urlsIf","urlsLiteralString","urlsModify","urlsOnObject","urlsOnToObject","urlsSet","urlsSetFromField","urlsOoCompare","urlsXget","urlsXset") 


//------------------------------------------------------
// dmClient URLscript commands
//------------------------------------------------------

//////////////////////////////////////
////////////// allocate //////////////

 a1 = new Arg("Class",allClassNames,allClassNamesValues,"Object",doS,"top.cmdFrame.razElements(this.form,\"Nat3\")")
 a2 = new Arg("Nat3" ,"","","?size? ",doT,"parseInt(this.value)||alert(\"nat3 is required\")")

 urlsAllocate = new Command("allocate","new Object",a1,a2,a2,a2,a2,a2,a2,a2,a2,a2,a2)
 if (debug) {urlsAllocate.doI(window,"top");document.write("<HR>")}


//////////////////////////////////////////////
////////////// connect //////////////
 
 a1 = new Arg("hostname","","","?hostname?",doT,"")
 a3 = new Arg("Nat3" ,"","","?portNumber? ",doT,"parseInt(this.value)||alert(\"nat3 is required\")")
 a2 = new Arg("passwd","","","?passwd?",doT,"")
 
 urlsConnect = new Command("connect","new Object",a1,a2,a3)
 if (debug) {urlsConnect.doI(window,"top");document.write("<HR>")}

////////////////////////////////////////////
////////////// createsubclass //////////////
 
 a1 = new Arg("superclass"    ,allClassNames,allClassNamesValues,"Object",doS,"")
 a2 = new Arg("className"     ,"","","?new_class_Name?",doT,"this.form.objectName.value=this.value")
 a3 = new Arg("classOptions"  ,dmClassOptionsNames,dmClassOptionsValues,dmClassDefaultOptionsValues,doS,"")
 a4 = new Arg("fieldName"     ,"","","?new_field_Name?",doT,"")
 a5 = new Arg("fieldOptions"  ,dmFieldOptionsNames,dmFieldOptionsValues,dmFieldDefaultOptionsValues,doS,"")
 a6 = new Arg("repetitionType",dmFieldRepetitionTypes,dmFieldRepetitionTypesValues,"nought",doS,"")
 a7 = new Arg("itemType"      ,dmTypeNames,dmTypeValues,"nat1",doS,"")
 a8 = new Arg("referringClass",dmClassNames,dmClassValues,"null",doS,"")

 urlsCreatesubclass = new Command("createsubclass","new Object",a1,a2,a3,a4,a5,a6,a7,a8)
 if (debug) {urlsCreatesubclass.doI(window,"top");document.write("<HR>")}

////////////////////////////////////
////////////// define //////////////
 
 a1 = new Arg("Object",allObjectNames,allObjectNamesValues,"Dictionary",doS,"")
 a2 = new Arg(".fields","","","?.field1.field2.field3?",doT,"")
 a3 = new Arg("name"  ,"","","?new_name?",doT,"")

 urlsDefine = new Command("define","name",a1,a2,a3)
 if (debug) {urlsDefine.doI(window,"top");document.write("<HR>")}

//////////////////////////////////////////////
////////////// get //////////////
 
 a1 = new Arg("Object"   ,allObjectNames,allObjectNamesValues,"--session defined--",doS,"")
 a2 = new Arg("---"      ,"","","dup classof",doB,"")
 a3 = new Arg("fieldName","","","?fieldName?",doT,"")
 a4 = new Arg("---"      ,"","","field",doB,"")

 urlsGet = new Command("get","new Object",a1,a2,a3,a4)
 if (debug) {urlsGet.doI(window,"top");document.write("<HR>")}

////////////////////////////////////
////////////// literalString /////////////
 
 a1 = new Arg("string"  ,"","","?new_string?",doT,"")

 urlsLiteralString = new Command("","Object",a1)
 if (debug) {urlsLiteralString.doI(window,"top");document.write("<HR>")}

//////////////////////////////////////
////////////// modify ////////////////

 a1 = new Arg("post string","","","?fieldName=value&fieldName=value?",doT,"")
 a2 = new Arg("Object",allObjectNames,allObjectNamesValues,"--session defined--",doS,"")

 urlsModify = new Command("modify","Object",a1,a2)
 if (debug) {urlsModify.doI(window,"top");document.write("<HR>")}


//////////////////////////////////////////////
////////////// onObject //////////////
 
 a1 = new Arg("Object"  ,allObjectNames,allObjectNamesValues,"thesite",doS,"")
 a2 = new Arg("command",dmOnObject,dmOnObject,"fancyprint",doS,"")

 urlsOnObject = new Command("        ","( )",a1,a2)
 if (debug) {urlsOnObject.doI(window,"top");document.write("<HR>")}

//////////////////////////////////////////////
////////////// onToObject //////////////
 
 a1 = new Arg("Object"    ,allObjectNames,allObjectNamesValues,"thesite",doS,"")
 a2 = new Arg("command",dmOnToObject,dmOnToObject,"classof",doS,"")

 urlsOnToObject = new Command("        ","new Object",a1,a2)
 if (debug) {urlsOnToObject.doI(window,"top");document.write("<HR>")}

//////////////////////////////////////////////
////////////// set //////////////
 
 a1 = new Arg("Object"   ,allObjectNames,allObjectNamesValues,"--session defined--",doS,"")
 a2 = new Arg("---"      ,"","","dup classof",doB,"")
 a3 = new Arg("fieldName","","","?fieldName?",doT,"")
 a4 = new Arg("---"      ,"","","field",doB,"")
 a5 = new Arg("value"    ,"","","?NewValue?",doT,"")

 urlsSet = new Command("set","Object",a1,a2,a3,a4,a5)
 if (debug) {urlsSet.doI(window,"top");document.write("<HR>")}

//////////////////////////////////////////////
////////////// setFromField //////////////
 
 a6 = new Arg(".fields"   ,"","","?.field1.field2.field3?",doT,"")

 urlsSetFromField = new Command("set","Object",a1,a2,a3,a4,a1,a6)
 if (debug) {urlsSetFromField.doI(window,"top");document.write("<HR>")}

//////////////////////////////////////////////
////////////// if //////////////
 
 a1 = new Arg("Object Then",allObjectNames,allObjectNamesValues,"item",doS,"")
 a2 = new Arg("Object Else",allObjectNames,allObjectNamesValues,"item",doS,"")
 a3 = new Arg("Object",allObjectNames,allObjectNamesValues,"item",doS,"")
 a4 = new Arg("---","","","==",doB,"")

 urlsIf = new Command(" if  ","Object",a1,a2,a3,a3,a4)
 if (debug) {urlsIf.doI(window,"top");document.write("<HR>")}

//////////////////////////////////////////////
////////////// oo== //////////////
 
 a1 = new Arg("Object",allObjectNames,allObjectNamesValues,"item",doS,"")

 urlsOoCompare = new Command("==","Boolean",a1,a1)
 if (debug) {urlsOoCompare.doI(window,"top");document.write("<HR>")}

//////////////////////////////////////////////
////////////// xget //////////////
 
 a1 = new Arg("Object"   ,allObjectNames,allObjectNamesValues,"--session defined--",doS,"")
 a2 = new Arg("---"      ,"","","dup classof",doB,"")
 a3 = new Arg("fieldName","","","?fieldName?",doT,"")
 a4 = new Arg("---"      ,"","","field",doB,"")
 a5 = new Arg("Nat3" ,"","","?index? ",doT,"parseInt(this.value)||alert(\"nat3 is required\")")

 urlsXget = new Command("xget","new Object",a1,a2,a3,a4,a5)
 if (debug) {urlsXget.doI(window,"top");document.write("<HR>")}

//////////////////////////////////////////////
////////////// xset //////////////
 
 a1 = new Arg("Object"   ,allObjectNames,allObjectNamesValues,"--session defined--",doS,"")
 a2 = new Arg("---"      ,"","","dup classof",doB,"")
 a3 = new Arg("fieldName","","","?fieldName?",doT,"")
 a4 = new Arg("---"      ,"","","field",doB,"")
 a5 = new Arg("Nat3" ,"","","?index? ",doT,"parseInt(this.value)||alert(\"nat3 is required\")")
 a6 = new Arg("value"    ,"","","?NewValue?",doT,"")

 urlsXset = new Command("xset","Object",a1,a2,a3,a4,a5,a6)
 if (debug) {urlsXset.doI(window,"top");document.write("<HR>")}

//////////////////////////////////////////////
////////////// XXX //////////////
 
 a1 = new Arg("string","","","?=?&?=?",doT,"")
 a2 = new Arg("Object",allObjectNames,allObjectNamesValues,"item",doS,"")

 urlsXXX = new Command("XXX","new Object",a1,a2)
 if (debug) {urlsXXX.doI(window,"top");document.write("<HR>")}

